﻿Option Strict On
Public Class frmHaupt

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Process.Start("mspaint.exe")        ' Beispielprogramm zum beenden!
        intZeitProzesse = 60
        intZeitRam = 60
    End Sub

    Dim intZeitProzesse, intZeitRam As Integer
    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        ' Prozesse auslesen..
        For Each prozlist As Process In Process.GetProcesses
            If prozlist.MainWindowTitle <> "" Then
                Try
                    If Not System.IO.Path.GetFileName(prozlist.MainModule.FileName.ToLower) = "explorer.exe" Then
                        Me.ListBox1.Items.Add(prozlist.MainWindowTitle)
                        Me.ListBox1.Items.Add(prozlist.MainModule.FileName.ToLower)
                    End If
                Catch
                End Try
            End If
        Next
        ÜbertragInListview()


        ' Anzeige...
        Me.lblProzesseAnzahl.Text = String.Format("{0} gefunden!", Me.lvAnwendungenListe.Items.Count.ToString)
        Me.lblProzesseInfofeld.Text = String.Format("Prozesse in {0} Sekunde(n)", (intZeitProzesse))
        Me.lblRAMInfofeld.Text = String.Format("Arbeitspeicher in {0} Sekunde(n)", intZeitRam)


        ' Prüfe ob aktevirt...
        If intZeitProzesse = 0 Then
            NeuesFensterProzesseFrageCode()
        End If

        ' Prüfe ob ram ..
        If intZeitRam = 0 Then
            NeuesFensterRAMFrageCode()
        End If


        ' Steuerung...
        If intZeitProzesse = 0 Then
            intZeitProzesse = 61
        End If
        If intZeitRam = 0 Then
            intZeitRam = 61
        End If
        ' Abziehen...
        If intZeitProzesse <> 0 Then intZeitProzesse -= 1
        If intZeitRam <> 0 Then intZeitRam -= 1
    End Sub

    Private Sub ÜbertragInListview()
        Dim filterliste As New List(Of String)
        ' Listbox1 übertragen in Listview...
        '1. ListBox1 to String...
        Dim einträgelstBox As String = ""
        For Each values As String In Me.ListBox1.Items
            einträgelstBox &= values & vbNullChar
        Next
        '2. String(ehemalige Listbox) splitten zu Fenster/Prozesennamen...
        Dim FensterProzessName() As String = einträgelstBox.Split(CType(vbNullChar, Char()))

        ' Clear alte Werte..
        Me.ListBox1.Items.Clear()
        Me.lvAnwendungenListe.Items.Clear()

        ' Werte ins Listview kopieren....
        For i As Integer = 0 To FensterProzessName.Length - 1
            Dim SubItem As ListViewItem
            With Me.lvAnwendungenListe.Items
                If FensterProzessName(i) <> "" Then
                    If Not filterliste.Contains(System.IO.Path.GetFileName(FensterProzessName(i + 1))) Then


                        SubItem = .Add(FensterProzessName(i)) : i += 1
                        SubItem.SubItems.Add(System.IO.Path.GetFileName(FensterProzessName(i)))
                        SubItem.SubItems.Add(FensterProzessName(i))


                    Else
                        i += 1
                    End If
                End If
            End With
        Next
    End Sub


    Public Sub NeuesFensterRAMFrageCode()

        Me.Timer1.Enabled = False
        Dim neuesFenster As New frmFensterFrage(False, lvAnwendungenListe.Items)
        neuesFenster.Text = "Arbeitspeicher"
        neuesFenster.ShowDialog()
        Me.Timer1.Enabled = True

    End Sub

    Private Sub NeuesFensterProzesseFrageCode()

        Me.Timer1.Enabled = False
        Dim neuesFenster As New frmFensterFrage(False, lvAnwendungenListe.Items)
        neuesFenster.Text = "Prozesse"
        neuesFenster.ShowDialog()
        Me.Timer1.Enabled = True

    End Sub



    REM
    ' debug
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        intZeitProzesse = 3
        intZeitRam = 3
    End Sub


End Class